/*
 * (c) Copyright 1995-1999, Igor Tarasov
 * FidoNet: 2:5020/370.2 620.20 1103.5
 * Inet: itarasov@rtuis.miem.edu.ru
 * Phone: (095)942-50-97
 */


#include <windows.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>

#include <stdlib.h> 
#include <time.h>


#define racket_w 2
#define racket_delta racket_w/2
#define initial_vilocity 0.1
#define radius 1

double x, y, z;
double racket_x, racket_z;
double vx, vy, vz;
double right = 5, left = -5, top = 5, bottom = -5, front = 3, back = -5;


 


void CALLBACK Key_LEFT(void )
{
 if(racket_x>left)
	 racket_x -= racket_delta;
}


void CALLBACK Key_RIGHT(void )
{
 if(racket_x+racket_w<right)
	 racket_x += racket_delta;
}


void CALLBACK Key_UP(void )
{
 if(racket_z>back)
	 racket_z -= racket_delta;
}

static void CALLBACK Key_DOWN(void )
{
 if(racket_z+racket_w<front)
	 racket_z += racket_delta;
}



int Catched()
{
 if(x>racket_x && x<racket_x+racket_w &&
	z>racket_z && z<racket_z+racket_w)
	return 1;
 else 
	return 0;
}



void GetNextXY()
{

  x += vx;
  y += vy;
  z += vz;

  if(x-radius<left || x+radius>right)
  {
      vx = -vx;
	  x += 2*vx;
  }

  if(z-radius<back || z+radius>front)
  {
      vz = -vz;
	  z += 2*vz;
  }


  
  if(y+radius>top || (y-radius<bottom && Catched()) )
  {
      vy = -vy;
	  y += 2*vy;
  }

}



void DrawScene(void)
{
    int i;
    double inc = racket_w;

	glColor3ub(0,255,0);

    for (i = 0; i < 5; i++) {

    /*
    ** Back
    */
    glBegin(GL_LINES);
        glVertex3d(left+i*inc, top,    back);
        glVertex3d(left+i*inc, bottom, back);
    glEnd();
    glBegin(GL_LINES);
        glVertex3d(right, bottom+i*inc, back);
        glVertex3d(left,  bottom+i*inc, back);
    glEnd();

    /*
    ** Left
    */
    glBegin(GL_LINES);
        glVertex3d(left, bottom+i*inc, front);
        glVertex3d(left, bottom+i*inc, back);
    glEnd();
    glBegin(GL_LINES);
        glVertex3d(left, top,    back+i*inc);
        glVertex3d(left, bottom, back+i*inc);
    glEnd();

    /*
    ** Right
    */
    glBegin(GL_LINES);
        glVertex3d(right, top-i*inc, front);
        glVertex3d(right, top-i*inc, back);
    glEnd();
    glBegin(GL_LINES);
        glVertex3d(right, top,    back+i*inc);
        glVertex3d(right, bottom, back+i*inc);
    glEnd();

    /*
    ** Top
    */
    glBegin(GL_LINES);
        glVertex3d(left+i*inc, top, front);
        glVertex3d(left+i*inc, top, back);
    glEnd();
    glBegin(GL_LINES);
        glVertex3d(right, top, back+i*inc);
        glVertex3d(left,  top, back+i*inc);
    glEnd();

    /*
    ** Bottom
    */
    glBegin(GL_LINES);
        glVertex3d(right-i*inc, bottom, front);
        glVertex3d(right-i*inc, bottom, back);
    glEnd();
    glBegin(GL_LINES);
        glVertex3d(right, bottom, back+i*inc);
        glVertex3d(left,  bottom, back+i*inc);
    glEnd();
    }
}



void DrawRacket()
{
 glPushMatrix();
   glTranslated(racket_x+racket_w/2, bottom, racket_z+racket_w/2);
   glColor3ub(0,0,255);
   auxSolidBox(racket_w, racket_w/10, racket_w);
 glPopMatrix();
}


void DrawBall()
{
	glPushMatrix();
        glTranslated(x,y,z);
	    glColor3d(1,0,0);
        auxSolidSphere(radius);
    glPopMatrix();
}




void CALLBACK display(void)
{

 glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );


   DrawScene(); 
   GetNextXY();
   DrawBall();
   DrawRacket();

		if(y<-4)
			auxQuit();

  auxSwapBuffers();

}




void CALLBACK resize(int width,int height)
{
   glViewport(0,0,width,height);
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glFrustum(-5,5, -5,5, 2,12);   
   gluLookAt( 0,0,5, 0,0,0, 0,1,0 );
   glMatrixMode( GL_MODELVIEW );
}    



void main()
{
//	float pos[4] = {3,3,3,1};
//	float dir[3] = {-1,-1,-1};


    srand(clock());

    vx=initial_vilocity+((double)(rand()%50))/1000.0;
    vy=initial_vilocity+((double)(rand()%50))/1000.0;
    vz=initial_vilocity+((double)(rand()%50))/1000.0;

    auxInitPosition( 50, 10, 400, 400);
    auxInitDisplayMode( AUX_RGB | AUX_DEPTH | AUX_DOUBLE );
    auxInitWindow( "Game --- Arcanoid" );
    auxIdleFunc(display);
    auxReshapeFunc(resize);

    auxKeyFunc(AUX_LEFT, Key_LEFT);
    auxKeyFunc(AUX_RIGHT, Key_RIGHT);
    auxKeyFunc(AUX_UP, Key_UP);
    auxKeyFunc(AUX_DOWN, Key_DOWN);


  
    glEnable(GL_ALPHA_TEST);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_COLOR_MATERIAL);
//    glEnable(GL_LIGHTING);
//    glEnable(GL_LIGHT0);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

//    glLightfv(GL_LIGHT0, GL_POSITION, pos);
//    glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, dir);

	auxMainLoop(display);
}
