/*
 * (c) Copyright 1995-2000, Igor Tarasov
 * FidoNet: 2:5020/370.2 620.20 1103.5
 * email: igor@itsoft.miem.edu.ru itarasov@rtuis.miem.edu.ru
 * Phone: (095)916-89-51 916-89-63
 */


#include <windows.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>

#include <stdio.h>

#define M_PI        3.14159265358979323846


float delta=0.1;



void Polar2Normal(float a, float b, float r, float nor[3])
{
nor[0] = r*cos(a)*cos(b);
nor[1] = r*sin(a);
nor[2] = -r*cos(a)*sin(b);
}

void Normal2Polar(float x, float y, float z, float pol[3]) 
{
pol[2] = sqrt(x*x+y*y+z*z);
pol[0] = asin(y/pol[2]);
pol[1] = acos(x/sqrt(x*x+z*z));
if(z>0)
 pol[1] = 2*M_PI - pol[1];
}


void CALLBACK Key_LEFT(void)
{
float nor[4];
float pol[3];

  glGetLightfv(GL_LIGHT3, GL_POSITION, nor);
  Normal2Polar(nor[0], nor[1], nor[2], pol);
  pol[1] -= delta;
  Polar2Normal(pol[0], pol[1], pol[2], nor);
  glLightfv(GL_LIGHT3, GL_POSITION, nor);
}

void CALLBACK Key_RIGHT(void)
{
float nor[4];
float pol[3];

  glGetLightfv(GL_LIGHT3, GL_POSITION, nor);
  Normal2Polar(nor[0], nor[1], nor[2], pol);
  pol[1] += delta;
  Polar2Normal(pol[0], pol[1], pol[2], nor);
  glLightfv(GL_LIGHT3, GL_POSITION, nor);
}


void CALLBACK Key_UP(void)
{
float nor[4];
float pol[3];

  glGetLightfv(GL_LIGHT3, GL_POSITION, nor);
  Normal2Polar(nor[0], nor[1], nor[2], pol);
  pol[0] += delta;
  Polar2Normal(pol[0], pol[1], pol[2], nor);
  glLightfv(GL_LIGHT3, GL_POSITION, nor);
}

void CALLBACK Key_DOWN(void)
{
float nor[4];
float pol[3];

  glGetLightfv(GL_LIGHT3, GL_POSITION, nor);
  Normal2Polar(nor[0], nor[1], nor[2], pol);
  pol[0] -= delta;
  Polar2Normal(pol[0], pol[1], pol[2], nor);
  glLightfv(GL_LIGHT3, GL_POSITION, nor);
}



void CALLBACK resize(int width,int height)
{
   glViewport(0,0,width,height);
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glOrtho(-5,5, -5,5, 2,12);   
   gluLookAt( 0,0,5, 0,0,0, 0,1,0 );
   glMatrixMode( GL_MODELVIEW );
}    



void CALLBACK display(void)
{
 glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	    glColor3d(1,1,1);
        auxSolidSphere(2);

  
  auxSwapBuffers();

}




void main()
{
float pos[4] = {3,3,3,1};
float dir[3] = {0,0,0};
float color[4] = {1,1,1,1};
float sp[4] = {1,1,1,1};
float mat_specular[] = {1,1,1,1};

    auxInitPosition( 50, 10, 400, 400);
    auxInitDisplayMode( AUX_RGB | AUX_DEPTH | AUX_DOUBLE );
    auxInitWindow( "Glaux Template" );
    auxIdleFunc(display);
    auxReshapeFunc(resize);

  
    glEnable(GL_DEPTH_TEST);

    glEnable(GL_COLOR_MATERIAL);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT5);
	glEnable(GL_LIGHT6);


    
    glLightfv(GL_LIGHT3, GL_SPECULAR, sp); 
    glLightfv(GL_LIGHT5, GL_SPECULAR, sp); 
    glLightfv(GL_LIGHT6, GL_SPECULAR, sp); 


    color[1]=color[2]=0;
    glLightfv(GL_LIGHT3, GL_DIFFUSE, color);

    color[0]=0;
	color[1]=1;
    glLightfv(GL_LIGHT5, GL_DIFFUSE, color);

    color[1]=0;
	color[2]=1;
    glLightfv(GL_LIGHT6, GL_DIFFUSE, color);


    glLightfv(GL_LIGHT3, GL_POSITION, pos);
	pos[0] = -3;
    glLightfv(GL_LIGHT5, GL_POSITION, pos);
	pos[0]=0;pos[1]=-3;
    glLightfv(GL_LIGHT6, GL_POSITION, pos);


	glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, dir);
    glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, dir);
    glLightfv(GL_LIGHT6, GL_SPOT_DIRECTION, dir);


    glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
    glMaterialf(GL_FRONT, GL_SHININESS, 128.0);


    auxKeyFunc(AUX_LEFT, Key_LEFT);
    auxKeyFunc(AUX_RIGHT, Key_RIGHT);
    auxKeyFunc(AUX_UP, Key_UP);
    auxKeyFunc(AUX_DOWN, Key_DOWN);


    auxMainLoop(display);
}
