/****************************************************************************
*                                                                           *
* pcx_2bpp.c -- Utilite to convert pcx to C array                           *
*                                                                           *
* Copyright (c) 1995-1999, Igor Tarasov. All rights reserved.               *
*                                                                           *
****************************************************************************/


//*********************************
#include<stdio.h>



typedef struct {
  char manufacturer;
  char version;
  char encoding;
  char bitsPerPixel;
  short int xmin, ymin;
  short int xmax, ymax;
  short int hres, vres;
  char palette[48];
  char reserved;
  char colourPlanes;
  short int bytesPerLine;
  short int paletteType;
  char filler[58];
} PCXHEAD;

PCXHEAD header;



//-------------------------------------
void main(int argc,char *name[])
{
	    FILE *in;
	    int i,j,n;
register    int c,v;
unsigned char array[128];


if( name[1] == '\x0')
{
  printf("Usage: pcx_2bpp [filename.pcx] \n");
  return;              
}



if( (in = fopen(name[1],"rb")) == NULL )
{
   printf("error in fopen(%s,rb)\n", name[1]);
   return;
}



if (!fread((char *)&header, sizeof(PCXHEAD), 1, in))
{
     printf("error in fread((char *)&header, sizeof(PCXHEAD), 1, in)\n");
     fclose(in);
     return;
}

 

printf("manufacturer = %d\n", header.manufacturer);
printf("version = %d\n", header.version);
printf("encoding = %d\n", header.encoding);
printf("bpp = %d\n", header.bitsPerPixel);
printf("xmin = %d ymin = %d\n", header.xmin, header.ymin);
printf("xmax = %d ymax = %d\n", header.xmax, header.ymax);
printf("hres = %d vres = %d\n", header.hres, header.vres);
printf("bytesPerLine = %d\n",  header.bytesPerLine);
printf("paletteType = %d\n\n", header.paletteType);


if( fseek(in,128,SEEK_SET) != 0)
{
	printf("error in fseek(in,128,SEEK_SET)\n");
    return;
}



for(i=0,j=0;i<=header.ymax-header.ymin;i++)
{
 n = 0;
do{
    c = fgetc(in);
if ((c&0xC0) == 0xC0)
    {
      v = c & 0x3F;
      c = fgetc(in);
      while (v--) {
		  n+=8;
		  array[j] = c;
		  j++;
		   }
    }
else
	{
    n+=8;
	array[j] = c;
    j++;
	}
  }
  while (n <=header.xmax-header.xmin);
}


printf("unsigned char array[] = {\n");

for(i=31;i>=0;i--)
{
 for(j=0;j<4;j++)
  printf("%d, ", array[4*i+j]);

 printf("\n");
}
printf("};\n");

fclose(in);
return;
}

